SystemOrganization addCategory: #SortingVisualization!

Morph subclass: #SVTower
	instanceVariableNames: 'corpus topMorph value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SortingVisualization'!

!SVTower class methodsFor: 'as yet unclassified' stamp: 'rms 6/14/2013 11:39:35.389'!
newWith: maxValue and: width and: value

	| newTower |
	newTower := self new.
	newTower extent: width@maxValue;
	         color: Color transparent;
			  corpus: BorderedMorph new;
			  value: value.
	(newTower corpus) color: Color gray;
						 height: value;
						 width: width;
						 borderColor: Color gray.
	newTower topMorph: BorderedMorph new.
	(newTower topMorph) color: Color black;
					 height: width;
					 width: width;
					 position: newTower corpus position.
	newTower corpus addMorphFront: newTower topMorph.
	newTower corpus position:  
		newTower corpus position + (0@(maxValue - value)).
	newTower addMorphFront: newTower corpus.
	newTower clipSubmorphs: true.
	^ newTower.! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 6/14/2013 11:06:30.916'!
< otherTower

	^value < otherTower value! !

!SVTower methodsFor: 'dragging' stamp: 'JH 6/19/2013 14:27:51.085'!
acceptDroppingMorph: aMorph event: evt

self halt.

self unmark.
self dependents do: [:aDependent| aDependent update: {self. aMorph} ]! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 13:21:50.395'!
corpus
	^corpus! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 13:22:00.376'!
corpus: aMorph
	corpus := aMorph.! !

!SVTower methodsFor: 'dragging' stamp: 'JH 6/19/2013 13:27:54.882'!
handlesMouseDown: evt

	^ true! !

!SVTower methodsFor: 'dragging' stamp: 'JH 6/19/2013 13:46:04.349'!
handlesMouseOverDragging: evt

	^ true
! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 6/17/2013 22:44:01.852'!
initialize

	super initialize.
	self dragEnabled: true.! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/30/2013 18:56:57.028'!
mark

	self corpus borderColor: Color yellow.
	self topMorph borderColor: Color yellow.! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/31/2013 14:27:08.027'!
min: tower

	(self value < tower value)
		ifTrue: [^self]
		ifFalse: [^tower].! !

!SVTower methodsFor: 'dragging' stamp: 'JH 6/19/2013 13:32:36.869'!
mouseDown: evt
	
	self owner mouseDown: evt.
	evt hand waitForClicksOrDrag: self event: evt.! !

!SVTower methodsFor: 'dragging' stamp: 'JH 6/19/2013 13:47:12.368'!
mouseEnterDragging: evt
	"Test button state elsewhere if at all"
	self mark! !

!SVTower methodsFor: 'dragging' stamp: 'JH 6/19/2013 13:47:22.02'!
mouseLeaveDragging: evt
	"Test button state elsewhere if at all"
	self unmark! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/30/2013 19:19:53.75'!
moveTo: newPosition

	| duration |
	duration := 300.
	self mark.
	(AnimPropertyAnimation 
		on: self 
		property: #position 
		start: self position 
		end: newPosition
		duration: duration) register;
							   finishBlock: [self unmark];
							   start.! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 6/2/2013 16:00:41.383'!
select

	self corpus borderColor: Color red.
	self topMorph borderColor: Color red.! !

!SVTower methodsFor: 'dragging' stamp: 'JH 6/19/2013 14:28:47.456'!
startDrag: evt

	evt hand grabMorph: self.! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 15:02:39.707'!
topMorph
	^topMorph! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 15:03:04.237'!
topMorph: aMorph
	topMorph := aMorph.! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/30/2013 18:57:25.156'!
unmark

	self corpus borderColor: Color gray.
	self topMorph borderColor: Color black.! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 15:41:51.965'!
value
	^value! !

!SVTower methodsFor: 'as yet unclassified' stamp: 'rms 5/23/2013 16:12:16.481'!
value: val
	value := val.! !

!SVTower methodsFor: 'dragging' stamp: 'JH 6/19/2013 14:33:33.638'!
wantsDroppedMorph: aMorph event: evt
(aMorph class name == #SVTower) ifTrue:[
self unmark.
self dependents do: [:aDependent| aDependent update: {self. aMorph} ]].

^false.! !

!SVTower methodsFor: 'dragging' stamp: 'JH 6/19/2013 14:32:27.154'!
wantsToBeDroppedInto: aMorph

	^ false! !

Object subclass: #SVMoveAnimation
	instanceVariableNames: 'speed moves towers positions stopAnimation animator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SortingVisualization'!

!SVMoveAnimation class methodsFor: 'as yet unclassified' stamp: 'rms 6/17/2013 12:57:10.92'!
newMoveOf: tower from: startPos to: endPos

	(self new createMoveFor: tower 
						 from: startPos 
							to: endPos) register; start.! !

!SVMoveAnimation class methodsFor: 'as yet unclassified' stamp: 'rms 6/17/2013 16:28:11.288'!
newSwapOf: towers between: positions withAnimator: animator

	| swapping |
	
	swapping := self new.
	swapping towers: towers;
			  positions: positions;
			  animator: animator;
			  initializeSwapping.
	^swapping.! !

!SVMoveAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 16:26:50.657'!
animator: animatorObject

	animator := animatorObject.! !

!SVMoveAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 11:16:51.629'!
changeSpeed: newSpeed

	moves do: [:move | move duration: 
								(move duration * (newSpeed / speed))].
	speed := newSpeed.! !

!SVMoveAnimation methodsFor: 'actions' stamp: 'rms 6/17/2013 21:34:44.878'!
cleanUp

	towers do: [:t | t unmark].
	animator animations remove: self ifAbsent: [].! !

!SVMoveAnimation methodsFor: 'animationCreation' stamp: 'rms 6/18/2013 23:28:11.669'!
createMoveFor: tower from: oldPos to: newPos

		^(AnimPropertyAnimation 
			on: tower 
			property: #position 
			start: oldPos 
			end: newPos
			duration: 500 * speed) 
				easingCurve: self expEaser.! !

!SVMoveAnimation methodsFor: 'initialization' stamp: 'rms 6/17/2013 11:32:19.361'!
expEaser
"return an easing function that eases according to an exponential"

	^ AnimEasingCurve new 
	     conversionBlock: 
			[:t | t := t*2.0. 
   			   (t < 1) 
      		    ifTrue: [0.5 * ((10.0 * (t - 1.0)) exp)]
          		 ifFalse: [t := t - 1. 
             		       0.5 * (2.0 - ((-10.0 * t) exp))]]! !

!SVMoveAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 11:28:06.961'!
finishBlock: aBlock

	moves first finishBlock: aBlock.! !

!SVMoveAnimation methodsFor: 'initialization' stamp: 'rms 6/18/2013 23:27:50.385'!
initialize
	 
	speed := 1.0.
	stopAnimation := false.! !

!SVMoveAnimation methodsFor: 'initialization' stamp: 'rms 6/17/2013 12:55:30.531'!
initializeMoving

	! !

!SVMoveAnimation methodsFor: 'initialization' stamp: 'rms 6/17/2013 21:28:25.607'!
initializeSwapping
	
	moves := {self createMoveFor: towers first 
								from: positions first 
								to: positions second .
				self createMoveFor: towers second 
								from: positions second 
								to: positions first}.
								
	self finishBlock: [self cleanUp].! !

!SVMoveAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 11:39:18.53'!
positions: anArray
	
	positions := anArray.! !

!SVMoveAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 13:12:02.65'!
previousAnimation: previousAnim

	previousAnim
		 finishBlock:
				[previousAnim cleanUp.
				 stopAnimation ifFalse: 
						[towers do: [:t | t mark;
				   	                        comeToFront].
						 moves do: [:a | a register; start]]].! !

!SVMoveAnimation methodsFor: 'actions' stamp: 'rms 6/17/2013 16:36:51.029'!
startAnimating 
	"As we got called, we have to be the initial animation"
	towers do: [:t | t mark].
	moves do: [:m | m register; start].! !

!SVMoveAnimation methodsFor: 'actions' stamp: 'rms 6/17/2013 12:48:58.965'!
stopAnimating 

	stopAnimation := true.! !

!SVMoveAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 11:30:01.815'!
towers
	
	^towers.! !

!SVMoveAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 11:39:03.714'!
towers: anArray
	
	towers := anArray.! !

Object subclass: #SVSelectAnimation
	instanceVariableNames: 'selection speed stopAnimation tower animator position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SortingVisualization'!

!SVSelectAnimation class methodsFor: 'as yet unclassified' stamp: 'rms 6/17/2013 16:26:12.149'!
newSelectFor: tower at: pos withAnimator: animator

	| selection |
	selection := self new.
	selection tower: tower;
			   position: pos;
				animator: animator;
				initializeAnimations.
	^selection! !

!SVSelectAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 16:26:35.936'!
animator: animatorObject

	animator := animatorObject.! !

!SVSelectAnimation methodsFor: 'configuration' stamp: 'rms 6/16/2013 17:10:33.81'!
changeSpeed: newSpeed

	selection duration: (selection duration * (newSpeed / speed)).
	speed := newSpeed.! !

!SVSelectAnimation methodsFor: 'actions' stamp: 'rms 6/17/2013 21:43:19.557'!
cleanUp

	tower unmark.
	animator animations remove: self ifAbsent: [].! !

!SVSelectAnimation methodsFor: 'animationCreation' stamp: 'rms 6/18/2013 23:28:06.457'!
createSelectionFor: tower at: pos

	^(AnimPropertyAnimation 
			on: tower 
			property: #position 
			start: pos 
			end: pos
			duration: 500 * speed).! !

!SVSelectAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 13:06:42.022'!
finishBlock: aBlock

	selection finishBlock: aBlock.! !

!SVSelectAnimation methodsFor: 'initialization' stamp: 'rms 6/18/2013 23:27:56.36'!
initialize
	
	speed := 1.0.
	stopAnimation := false.! !

!SVSelectAnimation methodsFor: 'initialization' stamp: 'rms 6/17/2013 21:28:33.477'!
initializeAnimations

		selection := self createSelectionFor: tower at: position. 
		selection finishBlock: [self cleanUp].! !

!SVSelectAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 13:05:29.075'!
position: pos

	position := pos.! !

!SVSelectAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 13:12:07.361'!
previousAnimation: previousAnim

	previousAnim
		 finishBlock:
				[previousAnim cleanUp.
				 stopAnimation ifFalse: 
					[tower select;
				     	    comeToFront.
				     selection register; 
								 start]].! !

!SVSelectAnimation methodsFor: 'actions' stamp: 'rms 6/17/2013 16:38:11.082'!
startAnimating 

	tower select.
	selection register; start.! !

!SVSelectAnimation methodsFor: 'actions' stamp: 'rms 6/17/2013 12:48:49.188'!
stopAnimating

	stopAnimation := true.! !

!SVSelectAnimation methodsFor: 'configuration' stamp: 'rms 6/17/2013 13:04:22.105'!
tower: aTower

	tower := aTower.! !

Object subclass: #SVTowerAnimator
	instanceVariableNames: 'speed animations previousTowers stopAnimation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SortingVisualization'!

!SVTowerAnimator methodsFor: 'animations' stamp: 'rms 6/17/2013 13:15:04.81'!
animations

	^animations.! !

!SVTowerAnimator methodsFor: 'animations' stamp: 'rms 6/17/2013 11:42:35.516'!
initialize

	animations := OrderedCollection new.
	stopAnimation := false.! !

!SVTowerAnimator methodsFor: 'animations' stamp: 'rms 6/17/2013 16:28:30.467'!
move: towers from: oldPos to: newPos
"queue an animated 'mark and move followed by unmark'"
	
	self queue: (SVMoveAnimation newSwapOf: towers 
									  between: {oldPos . newPos}
									  withAnimator: self).! !

!SVTowerAnimator methodsFor: 'queueing' stamp: 'rms 6/17/2013 11:39:54.471'!
queue: animation

	animations ifNotEmpty: [animation previousAnimation: animations last].
	animations addLast: animation.! !

!SVTowerAnimator methodsFor: 'animations' stamp: 'rms 6/17/2013 16:29:00.857'!
select: tower at: pos

	self queue: (SVSelectAnimation newSelectFor: tower 
										at: pos
										withAnimator: self).! !

!SVTowerAnimator methodsFor: 'animations' stamp: 'rms 6/16/2013 17:06:46.554'!
speed: newSpeed

	animations do: [:anim | anim changeSpeed: newSpeed].
	speed := newSpeed.! !

!SVTowerAnimator methodsFor: 'animations' stamp: 'rms 6/17/2013 11:40:55.219'!
startAnimating
"dispose animation after it has been activated"

	animations ifNotEmpty: [animations first startAnimating].

	! !

!SVTowerAnimator methodsFor: 'animations' stamp: 'rms 6/17/2013 21:34:57.702'!
stopAnimating

	animations do: [:anim | anim stopAnimating].
	animations removeAll.! !

BorderedMorph subclass: #SVSortItemVisualizer
	instanceVariableNames: 'items mover defaultExtent clickedTower arrayMorph tempMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SortingVisualization'!

!SVSortItemVisualizer class methodsFor: 'as yet unclassified' stamp: 'toma 6/19/2013 20:21:30.362'!
newForItems: items

	| visualizer |
	visualizer := self basicNew 
						defaultExtent: 400@300;
						initialize;
						setupSortingScape: (items asOrderedCollection);
						yourself.
			    
	(TransformationMorph new asFlexOf: visualizer) 
		clipSubmorphs: true;
		openInWorld.
	^visualizer
			
	! !

!SVSortItemVisualizer class methodsFor: 'as yet unclassified' stamp: 'toma 6/19/2013 13:01:20.663'!
newInRange: numberOfEntries

	^self newForItems: (1 to: numberOfEntries).! !

!SVSortItemVisualizer class methodsFor: 'as yet unclassified' stamp: 'rms 6/19/2013 12:59:08.935'!
sampleSorter

	^self newInRange: 30.! !

!SVSortItemVisualizer methodsFor: 'heapsort' stamp: 'rms 6/2/2013 13:46:54.95'!
at: a lessThanAt: b

	^(items at: a) value < (items at: b) value! !

!SVSortItemVisualizer methodsFor: 'animation' stamp: 'rms 6/2/2013 17:09:20.192'!
changeSpeed: newSpeed

	mover speed: newSpeed.! !

!SVSortItemVisualizer methodsFor: 'initialization' stamp: 'rms 6/18/2013 17:56:58.615'!
createNewTower: maxValue and: width and: value at: offset

	| newTower |
	newTower := SVTower newWith: maxValue and: width and: value.
	newTower position: self position + offset.
	newTower addDependent: self.
	items addLast: newTower. 
	self addMorphFront: newTower.! !

!SVSortItemVisualizer methodsFor: 'as yet unclassified' stamp: 'toma 6/19/2013 20:15:50.629'!
defaultExtent: aPoint
	defaultExtent := aPoint! !

!SVSortItemVisualizer methodsFor: 'heapsort' stamp: 'rms 6/2/2013 15:38:20.144'!
heapSort
"perform HeapSort on the set of items"

	self heapify.
	
	(items size to: 1 by: -1) do: 
		[:i | self siftDownFrom: 1 to: i. 
			   self swap: i with: 1.].
		
	self startAnimating.! !

!SVSortItemVisualizer methodsFor: 'heapsort' stamp: 'rms 6/2/2013 15:42:26.799'!
heapify

	| start |
	
	start := (items size / 2) asInteger.
	
	(start to: 1 by: -1) do: 
		[:i | self siftDownFrom: i to: items size].! !

!SVSortItemVisualizer methodsFor: 'initialization' stamp: 'toma 6/19/2013 20:28:28.001'!
initialize
	super initialize.
	items := OrderedCollection new.
	mover := SVTowerAnimator new.
	self 
		extent: defaultExtent;
		setupFrame.! !

!SVSortItemVisualizer methodsFor: 'itemActions' stamp: 'rms 6/2/2013 13:37:52.911'!
items
	^items! !

!SVSortItemVisualizer methodsFor: 'itemActions' stamp: 'rms 6/2/2013 13:22:36.04'!
positionFor: index

	| towerSample |
	towerSample := items first.
	^(self position x + ((index - 1) * towerSample width))@(towerSample position y).! !

!SVSortItemVisualizer methodsFor: 'itemActions' stamp: 'rms 6/14/2013 11:18:33.131'!
select: index

	mover select: (items at: index) at: (self positionFor: index).! !

!SVSortItemVisualizer methodsFor: 'selectionSort' stamp: 'rms 6/14/2013 11:17:52.76'!
selectionSort

	| min |

	items withIndexDo: 
			[:e :i | min := i.
					  self swap: i with: 
							[(i + 1 to: items size) do: 
										[:j | (items at: j) < (items at: min) ifTrue: [min := j].
											   self select: j]. min] value.].
	self startAnimating.
	! !

!SVSortItemVisualizer methodsFor: 'as yet unclassified' stamp: 'toma 6/19/2013 20:47:04.448'!
setupArrayAndTempMorph

	arrayMorph := BorderedMorph new
		position: (self position + (10 @ 10));
		extent: (self extent - (100 @ 20));
		color: (Color green muchLighter);
		borderColor: (Color green lighter);
		openInWorld.
		
	tempMorph := BorderedMorph new
		position: (arrayMorph topRight + (10 @ 0));
		extent: (70 @ arrayMorph height);
		color: (Color orange muchLighter);
		borderColor: (Color orange lighter);
		openInWorld.
		
	self 
		addMorphFront: arrayMorph;
		addMorphFront: tempMorph.
	
		
		! !

!SVSortItemVisualizer methodsFor: 'as yet unclassified' stamp: 'toma 6/19/2013 20:45:12.478'!
setupFrame

	self 
		color: Color white;
		borderColor: Color black;
		setupArrayAndTempMorph
	! !

!SVSortItemVisualizer methodsFor: 'initialization' stamp: 'rms 5/23/2013 14:07:28.874'!
setupFrameWithExtent: extent

	self extent: extent.
	self color: Color white.
	self borderColor: Color black.! !

!SVSortItemVisualizer methodsFor: 'initialization' stamp: 'rms 6/2/2013 12:48:43.091'!
setupSortingScape: sortingItems

	| towerOffset towerWidth towerHeight|
	
	towerWidth := 
		(self width / sortingItems size) asInteger.
	towerOffset := 0@0.
	
	sortingItems do: [:item |
		towerHeight := (self height / sortingItems max) * item.
		self createNewTower: self height
						  and: towerWidth 
						  and: towerHeight
						  at: towerOffset.
		towerOffset := towerOffset + ((towerWidth)@0)].! !

!SVSortItemVisualizer methodsFor: 'itemActions' stamp: 'rms 6/17/2013 21:20:45.003'!
shuffle

	items shuffle.
	items withIndexDo: 
		[:e :i | (SVMoveAnimation newMoveOf:e 
									 from: (e position) 
									 to: (self positionFor: i))].! !

!SVSortItemVisualizer methodsFor: 'heapsort' stamp: 'rms 6/2/2013 15:54:43.486'!
siftDownFrom: start to: end

	| root child swap |
	
	root := start.
	
	[(root * 2) <= end] whileTrue: 
		[ child := root * 2.
		  swap := root.
		  (self at: swap lessThanAt: child)
				ifTrue: [swap := child].
		  ((child + 1 <= end) and: [self at: swap lessThanAt: child + 1])
				ifTrue: [swap := child + 1].
		  (swap == root) 
				ifFalse: [self swap: root with: swap. 
						   root := swap]
				ifTrue: [root := end]].! !

!SVSortItemVisualizer methodsFor: 'animation' stamp: 'rms 6/2/2013 17:10:04.585'!
startAnimating 

	mover startAnimating.! !

!SVSortItemVisualizer methodsFor: 'animation' stamp: 'rms 6/14/2013 11:50:01.083'!
stopSorting

	mover stopAnimating.
	self shuffle.! !

!SVSortItemVisualizer methodsFor: 'itemActions' stamp: 'rms 6/17/2013 22:26:56.906'!
swap: firstIndex with: secondIndex

	| tmpTower |
	
	mover move: {(self items at: firstIndex) . (self items at: secondIndex)}
		   from: (self positionFor: firstIndex)
		   to: (self positionFor: secondIndex).
	
	tmpTower := items at: firstIndex.
	items at: firstIndex put: (self items at: secondIndex).
	items at: secondIndex put: tmpTower.! !

!SVSortItemVisualizer methodsFor: 'itemActions' stamp: 'JH 6/19/2013 14:03:39.815'!
update: aTupple
"a tower has been dropped onto a different tower"
	self swap: (items indexOf: aTupple first) with: (items indexOf: aTupple second).
	self startAnimating
	"clickedTower 
		ifNil: [clickedTower := aTower]
		ifNotNil: [self swap: (items indexOf: clickedTower)
						  with: (items indexOf: aTower).
					self startAnimating.
			       clickedTower unmark.
					aTower unmark.
					clickedTower := nil]"
	! !

!SVSortItemVisualizer methodsFor: 'dragging' stamp: 'JH 6/19/2013 13:43:22.952'!
wantsDroppedMorph: aMorph event: evt

^ false! !
